Bug 92381 - (NET TG3) No way to pass module options to tg3 driver
(NET TG3) No way to pass module options to tg3 driver
Status: CLOSED WONTFIX
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
9
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: David Miller
Brian Brock
: FutureFeature
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2003-06-05 13:43 EDT by Brian Baggett
Modified: 2007-04-18 12:54 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-03-03 00:37:29 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Brian Baggett 2003-06-05 13:43:49 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.3) Gecko/20030312

Description of problem:
I cannot pass options to the tg3 driver to force it to a speed and duplex
setting.  My employer refuses to turn on autonegotiation on the switches.  I
have to force it with ethtool and this seems kludgy.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Install driver in modules.conf.
2. Use ethtool to force it to do what it should.
    

Additional info:
Comment 1 Arjan van de Ven 2003-06-05 13:47:06 EDT
ethtool is actually the prefered method.
Comment 2 Brian Baggett 2003-06-05 13:59:10 EDT
May I ask why is it the preferred method?

I need to perform a kickstart over a broadcom interface using RH 9 and PXE boot.
 To get the install to work, I have to make it 100 Mb / full duplex.  With any
other network card, I can pass parameters to the kernel.  I can't do this if I
have to use ethtool or can I?

Looking at the source, it seems as if it wouldn't be too difficult to make this
an option.  Would a patch be accepted if I could produce it?
Comment 3 Brian Baggett 2003-06-12 17:13:53 EDT
<i> I need to perform a kickstart over a broadcom interface using RH 9 and PXE
boot. To get the install to work, I have to make it 100 Mb / full duplex.  With
any other network card, I can pass parameters to the kernel.  I can't do this if
I have to use ethtool or can I?</i>

The following works in RH AS, does this capability exist in RH 9?

http://www.redhat.com/docs/manuals/enterprise/RHEL-AS-2.1-Manual/release-notes/RELEASE-NOTES-U2

autonegotiation
settings via ethtool for ethernet devices which support its use at
installation time.  This capability does not extend to the installed
system.
		  
For example:  

boot: linux eth0_ethtool="speed=100 autoneg=off duplex=full"
-or- boot: linux eth1_ethtool="speed=10 duplex=half"
		   
Valid ethtool directives and their options are as follows:
- speed: Specifies interface speed.  Valid values are 10, 100,and 1000.

- autoneg: Specifies whether or not the interface should attempt
autonegotiation.  Valid values are on and off.
		   
- duplex: Forces the duplex setting of an interface to the specified value. 
Valid values are half and full.
		   
These options are only effective for drivers that support the ethtool ioctls
(which includes e1000, e100, and tg3).
Comment 4 Jeff Garzik 2004-03-03 00:37:07 EST
Module options are deprecated in favor of ethtool.
Comment 5 D Deighton 2004-04-20 12:55:15 EDT
Adding a 3 second sleep in front of the ethtool command allowed us to
run ethtool from modules.conf.  We preferred this method to doing it
manually or modifying existing scripts.  Here's an excerpt from
/etc/modules.conf:

alias eth0 tg3
alias eth1 tg3
post-install tg3 sleep 3; /sbin/ethtool -s eth0 speed 100 duplex full
autoneg off

Note You need to log in before you can comment on or make changes to this bug.